/******************************************************************************
 *
 * File			:	jk_msg.h
 *	
 *	Author		:	Jayakumar B
 *
 *	Created 	:	28th April 2003
 *
 * Description	:	This file is header file for Linux Message Queues
 *
*******************************************************************************/

#if 0
#include <stdio.h>
#include <stdlib.h>
#include </usr/src/linux-2.4.2/include/asm-i386/errno.h>
#include </usr/src/linux-2.4.2/include/asm-i386/unistd.h>
// #include </usr/src/linux-2.4.2/include/asm/current.h>
#include <linux/linkage.h>
#include <sys/types.h>
#include <sched.h>
#endif

// #include <linux/linkage.h>
// #include <sys/types.h>

#include <linux/config.h>
#include <linux/slab.h>
// #include <linux/msg.h>
#include <linux/spinlock.h>
#include <linux/init.h>
#include <linux/list.h>
//#include </usr/src/linux-2.4.2/include/linux/wait.h>
// #include <asm/uaccess.h>
#include </usr/src/linux-2.4.2/include/asm-i386/unistd.h>
#include </usr/src/linux-2.4.2/include/asm-i386/errno.h>
// #include <time.h>


#if 0
#include <sys/types.h>
#include <unistd.h>
#endif


/* Preprocessor Macros */
#define JK_MAX_MESSAGE_SIZE		4096
#define JK_MAX_MSG_BYTES		400
#define JK_MSGQ_MAX_ENTRY		20

/* Permission related fields */
#define JK_IPC_CREAT			0x0400
#define JK_IPC_EXCL				0x0200
#define JK_IPC_EXCL_CREAT		0x0600
#define JK_MSG_NOERROR			0x0800
#define JK_IPC_PERM_FIELD		0x01ff 
/* Function return values */
#define JK_SUCCESS				0
#define JK_FAILURE				-1

/* Message Queue search parameters */
#define JK_KEY_SEARCH			1
#define JK_QID_SEARCH			2

/* Message Queue control parameters */
#define JK_IPC_STAT				10
#define JK_IPC_SET				20
#define JK_IPC_RMID				30
#define JK_IPC_NOWAIT			40


/* Message Queue length status */
#define JK_QUEUE_EMPTY			40
#define JK_QUEUE_NOT_EMPTY		50

/* Message Queue access permissions */
#define JK_ALL_READ 			0x0004
#define JK_ALL_WRITE			0x0002
#define JK_GROUP_READ			0x0020
#define JK_GROUP_WRITE			0x0010
#define JK_USER_READ			0x0100
#define JK_USER_WRITE			0x0080



/* Type definitions */
#define key_t 	int 
#define ushort 	unsigned short
#define time_t  unsigned long int

/* Type definitions for structure pointers */
typedef struct JK_msgqid_ds* DSPTR;
typedef struct JK_msg* MSGPTR;
/* Structure Definitions */

/* Structure for IPC permissions */
struct JK_ipc_perm {
	key_t		key;
	ushort		uid;
	ushort		gid;
	ushort		cuid;
	ushort		cgid;
	ushort		mode;
	int			seq;
};

/* Structure for holding the message in the Kernel space */
struct JK_msg
{
	struct JK_msg	*msg_next;
	long			msg_type;
	char*			msg_spot;
	short			msg_ts;
};

/* Structre for holding the message in the user space */
struct JK_msgbuf
{
	int 	mtype;
	char*	mtext[1];
};

struct mymsg
{
	int 	mtype;
	int		tos;
	int		length;
};


/* Structure for Message Queue data structure */
struct JK_msgqid_ds {
	struct JK_ipc_perm		 msg_perm;
	struct JK_msgqid_ds		 *ds_next;
	struct __wait_queue_head  	 *rwait;
	struct __wait_queue_head	 *wwait;
	struct JK_msg	*msg_first;
	struct JK_msg	*msg_last;
	ushort			msg_cbytes;
	ushort			msg_qnum;
	ushort			msg_qbytes;
	ushort			msg_lspid;
	ushort			msg_lrpid;
	time_t			msg_stime;
	time_t			msg_rtime;
	time_t			msg_ctime;
};
	
			
	




